package ch.psi.daq.test.queryrest.query;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.List;
import java.util.stream.Collectors;

import javax.annotation.Resource;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.springframework.context.ApplicationContext;

import ch.psi.daq.domain.backend.Backend;
import ch.psi.daq.domain.query.channels.ChannelsRequest;
import ch.psi.daq.queryrest.config.QueryRestConfig;
import ch.psi.daq.queryrest.query.QueryManager;
import ch.psi.daq.test.queryrest.AbstractDaqRestTest;

public class QueryManagerRemoteTest extends AbstractDaqRestTest {

   @Resource
   private ApplicationContext context;
   private QueryManager queryManager;

   @Before
   public void setUp() throws Exception {
      queryManager = context.getBean(QueryRestConfig.BEAN_NAME_QUERY_MANAGER_REMOTE, QueryManager.class);
   }

   @After
   public void tearDown() {}

   @Test
   public void testQueryManager_01() throws Exception {
      final List<Backend> backends = queryManager.getBackends().collect(Collectors.toList());
      assertEquals(7, backends.size());

      final List<String> channels = queryManager.getChannels(new ChannelsRequest())
            .flatMap(response -> response.getChannels().stream())
            .collect(Collectors.toList());
      assertTrue("Size was " + channels.size(), channels.size() > 400000);
   }
}
